"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var CredentialRequest_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.constraintFunctions = exports.CredentialRequest = void 0;
const jsonlogic = __importStar(require("json-logic-js"));
const class_transformer_1 = require("class-transformer");
let CredentialRequest = CredentialRequest_1 = class CredentialRequest {
    constructor() {
        this._credentialRequirements = [];
    }
    get credentialRequirements() {
        return this._credentialRequirements;
    }
    set credentialRequirements(requirements) {
        this._credentialRequirements = requirements;
    }
    get callbackURL() {
        return this._callbackURL;
    }
    set callbackURL(callback) {
        this._callbackURL = callback;
    }
    get requestedCredentialTypes() {
        return this.credentialRequirements.map(credential => credential.type);
    }
    applyConstraints(credentials) {
        return credentials.filter(credential => {
            const relevantConstraints = this.credentialRequirements.find(section => areCredTypesEqual(section.type, credential.type));
            if (!relevantConstraints) {
                return false;
            }
            if (!relevantConstraints.constraints.length) {
                return credential;
            }
            const combinedRequirements = { and: relevantConstraints.constraints };
            if (relevantConstraints) {
                return jsonlogic.apply(combinedRequirements, credential);
            }
        });
    }
    toJSON() {
        return (0, class_transformer_1.classToPlain)(this);
    }
    static fromJSON(json) {
        return (0, class_transformer_1.plainToClass)(CredentialRequest_1, json);
    }
};
__decorate([
    (0, class_transformer_1.Expose)()
], CredentialRequest.prototype, "credentialRequirements", null);
__decorate([
    (0, class_transformer_1.Expose)()
], CredentialRequest.prototype, "callbackURL", null);
CredentialRequest = CredentialRequest_1 = __decorate([
    (0, class_transformer_1.Exclude)()
], CredentialRequest);
exports.CredentialRequest = CredentialRequest;
exports.constraintFunctions = {
    is: (field, value) => assembleStatement('==', field, value),
    not: (field, value) => assembleStatement('!=', field, value),
    greater: (field, value) => assembleStatement('>', field, value),
    smaller: (field, value) => assembleStatement('<', field, value),
};
const assembleStatement = (operator, field, value) => ({ [operator]: [{ var: field }, value] });
const areCredTypesEqual = (first, second) => first.every((el, index) => el === second[index]);
//# sourceMappingURL=credentialRequest.js.map