"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shardsToMnemonic = exports.sliceSeedPhrase = exports.SEED_PHRASE_LENGTH_LIST = void 0;
const bip39_1 = require("bip39");
const socialRecovery_1 = require("./socialRecovery");
exports.SEED_PHRASE_LENGTH_LIST = [12, 15, 18, 21, 24];
function sliceSeedPhrase(seedPhrase) {
    const seedPhraseArray = seedPhrase.split(' ');
    const divideAt = exports.SEED_PHRASE_LENGTH_LIST.find(l => (0, bip39_1.validateMnemonic)(seedPhraseArray.slice(0, l).join(' ')));
    const firstEncodedValue = seedPhraseArray.slice(0, divideAt);
    const secondEncodedValue = seedPhraseArray.slice(divideAt);
    return {
        seed: (0, bip39_1.mnemonicToEntropy)(firstEncodedValue.join(' ')),
        encodedDid: secondEncodedValue.length &&
            (0, bip39_1.mnemonicToEntropy)(secondEncodedValue.join(' ')),
    };
}
exports.sliceSeedPhrase = sliceSeedPhrase;
const shardsToMnemonic = async (shards) => {
    const { did, secret } = socialRecovery_1.SocialRecovery.combineShard(shards);
    return {
        didPhrase: (0, bip39_1.entropyToMnemonic)(Buffer.from(did, 'hex')),
        seed: (0, bip39_1.entropyToMnemonic)(secret),
    };
};
exports.shardsToMnemonic = shardsToMnemonic;
//# sourceMappingURL=recovery.js.map