"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.entropyToMnemonic = exports.mnemonicToEntropy = exports.getRandomBytes = exports.sha256 = void 0;
const create_hash_1 = __importDefault(require("create-hash"));
const vaulted_key_provider_1 = require("@jolocom/vaulted-key-provider");
const native_core_1 = require("@jolocom/native-core");
function sha256(data) {
    return (0, create_hash_1.default)('sha256')
        .update(data)
        .digest();
}
exports.sha256 = sha256;
async function getRandomBytes(nr) {
    return (0, vaulted_key_provider_1.getCryptoProvider)(native_core_1.cryptoUtils).getRandom(nr);
}
exports.getRandomBytes = getRandomBytes;
var bip39_1 = require("bip39");
Object.defineProperty(exports, "mnemonicToEntropy", { enumerable: true, get: function () { return bip39_1.mnemonicToEntropy; } });
Object.defineProperty(exports, "entropyToMnemonic", { enumerable: true, get: function () { return bip39_1.entropyToMnemonic; } });
//# sourceMappingURL=crypto.js.map